
/******************************************************************************
* MODULE     : interval_lower.cpp
* DESCRIPTION: Compute the lower limit of the interval
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

dyadic
lower (const interval& x) {
  if (has_low_prec (x)) {
    dyadic r (DEFAULT_LOW);
    mpfr_set (*r, x->min, GMP_RNDD);
    return r;
  }
  else {
    dyadic r (x->mid);
    mpfr_sub (*r, x->mid, x->rad, GMP_RNDD);
    return r;
  }
}

} // namespace mml
