
/******************************************************************************
* MODULE     : symbolic_defs.cpp
* DESCRIPTION: Globally defined symbolic expressions
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "symbolic_aux.hpp"
namespace mml {

table<symbolic_rep*,symbolic_aux> symbolic_entries ((symbolic_rep*) NULL);

symbolic SYMB_UNKNOWN ("#unknown#");
symbolic SYMB_ATOM ("#atom#");
symbolic SYMB_INTEGER ("#integer#");
symbolic SYMB_RATIONAL ("#rational#");
symbolic SYMB_COMPOUND ("#compound#");
symbolic SYMB_SUM ("#sum#");
symbolic SYMB_PRODUCT ("#product#");

symbolic SYMB_ZERO (0);
symbolic SYMB_ONE  (1);

symbolic SYMB_LESSLESS ("<<");
symbolic SYMB_GTRGTR (">>");
symbolic SYMB_IMPLIES ("=>");
symbolic SYMB_EQUIV ("<=>");
symbolic SYMB_OR ("&&");
symbolic SYMB_XOR ("^^");
symbolic SYMB_AND ("||");
symbolic SYMB_EQUAL ("=");
symbolic SYMB_UNEQUAL ("!=");
symbolic SYMB_LESS ("<");
symbolic SYMB_LESSEQ ("<=");
symbolic SYMB_GTR (">");
symbolic SYMB_GTREQ (">=");
symbolic SYMB_FUNCTION ("->");
symbolic SYMB_PLUS ("+");
symbolic SYMB_TIMES ("*");
symbolic SYMB_OVER ("/");
symbolic SYMB_COMPOSE ("@");
symbolic SYMB_NOT ("!");
symbolic SYMB_MINUS ("-");
symbolic SYMB_POWER ("^");
symbolic SYMB_FACTORIAL (".!");
symbolic SYMB_PRIME ("'");
symbolic SYMB_DOT (".");
symbolic SYMB_ACCESS (".[]");
symbolic SYMB_TUPLE ("tuple!");
symbolic SYMB_VTUPLE ("vtuple!");
symbolic SYMB_SQTUPLE ("[]");

} // namespace mml
